package com.nisum.myteam.model;

import java.io.Serializable;
import java.util.Date;

import org.bson.types.ObjectId;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.format.annotation.DateTimeFormat.ISO;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;

@Setter
@Getter
@AllArgsConstructor
@NoArgsConstructor
@ToString
@Document(collection = "billing")
public class Billing extends AuditFields implements Serializable {

	public Date getBillingEndDate() {
		return billingEndDate;
	}

	private static final long serialVersionUID = 1L;

	@Id
	private ObjectId id;
	private String employeeId;
	private String employeeName;
	private String account;
	private String projectId;
	private String projectName;
	private String billableStatus;
	@DateTimeFormat(iso = ISO.DATE)
	private Date billingStartDate;
	@DateTimeFormat(iso = ISO.DATE)
	private Date billingEndDate;
	private String comments;
	private boolean active;
	// @DateTimeFormat(pattern = "dd-MM-yyyy")
	// private Date createDate;

}
